/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the WarmupStatus type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &WarmupStatus{}

// WarmupStatus struct for WarmupStatus
type WarmupStatus struct {
	WarmedUp *bool `json:"warmedUp,omitempty"`
}

// NewWarmupStatus instantiates a new WarmupStatus object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewWarmupStatus() *WarmupStatus {
	this := WarmupStatus{}
	return &this
}

// NewWarmupStatusWithDefaults instantiates a new WarmupStatus object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewWarmupStatusWithDefaults() *WarmupStatus {
	this := WarmupStatus{}
	return &this
}

// GetWarmedUp returns the WarmedUp field value if set, zero value otherwise.
func (o *WarmupStatus) GetWarmedUp() bool {
	if o == nil || IsNil(o.WarmedUp) {
		var ret bool
		return ret
	}
	return *o.WarmedUp
}

// GetWarmedUpOk returns a tuple with the WarmedUp field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *WarmupStatus) GetWarmedUpOk() (*bool, bool) {
	if o == nil || IsNil(o.WarmedUp) {
		return nil, false
	}
	return o.WarmedUp, true
}

// HasWarmedUp returns a boolean if a field has been set.
func (o *WarmupStatus) HasWarmedUp() bool {
	if o != nil && !IsNil(o.WarmedUp) {
		return true
	}

	return false
}

// SetWarmedUp gets a reference to the given bool and assigns it to the WarmedUp field.
func (o *WarmupStatus) SetWarmedUp(v bool) {
	o.WarmedUp = &v
}

func (o WarmupStatus) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o WarmupStatus) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.WarmedUp) {
		toSerialize["warmedUp"] = o.WarmedUp
	}
	return toSerialize, nil
}

type NullableWarmupStatus struct {
	value *WarmupStatus
	isSet bool
}

func (v NullableWarmupStatus) Get() *WarmupStatus {
	return v.value
}

func (v *NullableWarmupStatus) Set(val *WarmupStatus) {
	v.value = val
	v.isSet = true
}

func (v NullableWarmupStatus) IsSet() bool {
	return v.isSet
}

func (v *NullableWarmupStatus) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableWarmupStatus(val *WarmupStatus) *NullableWarmupStatus {
	return &NullableWarmupStatus{value: val, isSet: true}
}

func (v NullableWarmupStatus) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableWarmupStatus) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
